stages:
  - test
  - deploy
  - post

publish:
  image: node:latest
  stage: deploy
  rules:
    - if: $CI_COMMIT_BRANCH == $CI_DEFAULT_BRANCH || $CI_COMMIT_REF_NAME =~ /^v\d+\.\d+\.\d+.*$/
      changes:
        - package.json
  script:
    # Extract a few values from package.json
    - NPM_PACKAGE_NAME=$(node -p "require('./package.json').name")
    - NPM_PACKAGE_VERSION=$(node -p "require('./package.json').version")
    - echo "Deploying ${NPM_PACKAGE_VERSION} of ${NPM_PACKAGE_NAME}"

    # Write the API token for the registry to .npmrc
    - echo "//registry.npmjs.org/:_authToken=${NPM_CI_TOKEN}" > ~/.npmrc

    # Compare the version in package.json to all published versions.
    # If the package.json version has not yet been published, run `npm publish`.
    - |
      if [[ "$(npm view ${NPM_PACKAGE_NAME} versions)" != *"'${NPM_PACKAGE_VERSION}'"* ]]; then
        npm publish --access public
        echo "Successfully published version ${NPM_PACKAGE_VERSION} of ${NPM_PACKAGE_NAME}"
      else
        echo "Version ${NPM_PACKAGE_VERSION} of ${NPM_PACKAGE_NAME} has already been published, so no new version has been published."
      fi

test-package:
  image: node:latest
  stage: post
  script:
    # Attempt to install locally
    - npm install @keyrock-dev/cornerstone
# TODO: Verify that .env exists
# TODO: Verify that client/dist/jotun-client.js was written
